import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import netP5.*; 
import oscP5.*; 
import java.awt.*; 
import java.awt.event.KeyAdapter; 
import java.awt.event.KeyEvent; 
import javax.swing.*; 
import javax.swing.JFrame; 

import oscP5.*; 
import netP5.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class OSC_bouncer extends PApplet {






 

// /composition/layers/1/clips/1/transport/position/behaviour/beats


OscP5 oscP5;
boolean mouseOverLink;
OscMessage myMessage =  new OscMessage("/");
OscBundle myBundle = new OscBundle();

//set this to the port you have Resolume Incoming OSC port set to
int portToSendTo =7000;

//set this to the port you have Resolume outgoing OSC port set to
int portToListenTo = 7001;

NetAddress Destination;
String linkUrl = "http://programs.palffyzoltan.hu";
int counter=0;
public void setup() {
  size(1000, 140);
  frameRate(60);
  frame.setTitle("OSC bouncer v0.1");
  OscProperties myProperties = new OscProperties();
  myProperties.setDatagramSize(4096); 
  myProperties.setListeningPort(portToListenTo);
  oscP5 = new OscP5(this, myProperties);

}


public void draw() {
  background(100);
  text(linkUrl+"     Set output port in your program to "+portToListenTo+ " and listen port to "+ portToSendTo,10,15);
  text(msg[0],30,35);
  text(msg[1],30,55);
  text(msg[2],30,75);
  text(msg[3],30,95);
  text(msg[4],30,115);
  
}



String [] msg = new String[]{
"","","","","","","","","",""
};

public void oscEvent(OscMessage theOscMessage) {

 msg [1] = msg [0]; 
 msg [2] = msg [1]; 
 msg [3] = msg [2]; 
 msg [4] = msg [3]; 
 msg [5] = msg [4]; 
  
  if (theOscMessage.typetag().equals("s")) {
    msg [0] =  theOscMessage.toString() +" "+ theOscMessage.get(0) ; 
  }
  if (theOscMessage.typetag().equals("f")) {
    msg [0] =  theOscMessage.toString() +" "+ theOscMessage.get(0).floatValue() ; 
  }
  if (theOscMessage.typetag().equals("i")) {
    msg [0] = theOscMessage.toString() +" "+ theOscMessage.get(0).intValue(); 
  }
  

  println(msg);
    myBundle.clear();
    myBundle.add(theOscMessage);
    Destination= new NetAddress(theOscMessage.netAddress().address(), portToSendTo);
    oscP5.send(myBundle, Destination);
  
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "OSC_bouncer" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
